Vector = Object:new()

local sincache = {}

function Vector:Vector(x, y, z)
	self.x = x
	self.y = y
	self.z = z
end

function Vector:__add(vec)
	return Vector:new(self.x + vec.x, self.y + vec.y, self.z + vec.z)
end

function Vector:add(vec)
	self.x, self.y, self.z = self.x + vec.x, self.y + vec.y, self.z + vec.z
	return self
end

function Vector:__sub(vec)
	return Vector:new(self.x - vec.x, self.y - vec.y, self.z - vec.z)
end

function Vector:__mul(scalar)
	return Vector:new(self.x*scalar, self.y*scalar, self.z*scalar)
end

function Vector:normal()
	local mag = math.sqrt(self.x * self.x + self.y * self.y + self.z * self.z)

	if mag == 0 then mag = 1 end
	return Vector:new(self.x/mag, self.y/mag, self.z/mag), mag
end

function Vector:inlinenormal()
	local mag = math.sqrt(self.x * self.x + self.y * self.y + self.z * self.z)

	if mag == 0 then mag = 1 end
	return self.x/mag, self.y/mag, self.z/mag, mag
end

function Vector:transform(vec)
	local x = self.x + vec.x
	local y = self.y + vec.y
	local z = self.z + vec.z
	return Vector:new(x, y, z)
end